Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs	(revision 10976)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs	(revision 10977)
@@ -56,5 +56,6 @@
 
           return (ITransformation)typeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType(new[] { columnNames });
-        } catch (Exception ex) {
+        }
+        catch (Exception ex) {
           ErrorHandling.ShowErrorDialog(this, ex);
         }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs	(revision 10976)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs	(revision 10977)
@@ -67,5 +67,5 @@
           new FilterContent(filterLogic),
           new ManipulationContent(manipulationLogic, searchLogic, dataGridLogic, filterLogic),
-          new TransformationContent(data)
+          new TransformationContent(data, filterLogic)
         };
 
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs	(revision 10976)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs	(revision 10977)
@@ -419,4 +419,5 @@
       this.lblPreviewInActive.Text = "Filters are active and thus manipulations cannot be applied!\r\n\r\nPlease deactive t" +
     "he filter(s) first in order to be able to perform manipulations.";
+      this.lblPreviewInActive.Visible = false;
       // 
       // tabPreviewDeleteColumnsInfo
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.cs	(revision 10976)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.cs	(revision 10977)
@@ -45,5 +45,4 @@
       tabsPreview.ItemSize = new Size(0, 1);
       tabsPreview.SizeMode = TabSizeMode.Fixed;
-      lblPreviewInActive.Visible = false;
 
       validators = new Action[] { 
@@ -73,5 +72,5 @@
         }
         cmbVariableNames.SelectedIndex = 0;
-        checkFilters();
+        CheckFilters();
       }
     }
@@ -91,9 +90,9 @@
     private void FilterLogic_FilterChanged(object sender, EventArgs e) {
       if (Content != null) {
-        checkFilters();
-      }
-    }
-
-    private void checkFilters() {
+        CheckFilters();
+      }
+    }
+
+    private void CheckFilters() {
       if (Content.FilterLogic.IsFiltered) {
         tabsPreview.SelectedIndex = 0;
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.Designer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.Designer.cs	(revision 10976)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.Designer.cs	(revision 10977)
@@ -47,21 +47,9 @@
     /// </summary>
     private void InitializeComponent() {
-      this.transformationListView = new HeuristicLab.DataPreprocessing.Views.CheckedTransformationListView();
       this.applyButton = new System.Windows.Forms.Button();
       this.preserveColumnsCheckbox = new System.Windows.Forms.CheckBox();
+      this.lblFilterNotice = new System.Windows.Forms.Label();
+      this.transformationListView = new HeuristicLab.DataPreprocessing.Views.CheckedTransformationListView();
       this.SuspendLayout();
-      // 
-      // transformationListView
-      // 
-      this.transformationListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.transformationListView.Caption = "Transformations";
-      this.transformationListView.Content = null;
-      this.transformationListView.Location = new System.Drawing.Point(0, 0);
-      this.transformationListView.Name = "transformationListView";
-      this.transformationListView.ReadOnly = false;
-      this.transformationListView.Size = new System.Drawing.Size(627, 482);
-      this.transformationListView.TabIndex = 0;
       // 
       // applyButton
@@ -87,8 +75,33 @@
       this.preserveColumnsCheckbox.UseVisualStyleBackColor = true;
       // 
+      // lblFilterNotice
+      // 
+      this.lblFilterNotice.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.lblFilterNotice.AutoSize = true;
+      this.lblFilterNotice.Location = new System.Drawing.Point(20, 493);
+      this.lblFilterNotice.Name = "lblFilterNotice";
+      this.lblFilterNotice.Size = new System.Drawing.Size(274, 13);
+      this.lblFilterNotice.TabIndex = 3;
+      this.lblFilterNotice.Text = "Transformations cannot be applied since a filter is active!";
+      this.lblFilterNotice.Visible = false;
+      // 
+      // transformationListView
+      // 
+      this.transformationListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.transformationListView.Caption = "Transformations";
+      this.transformationListView.Content = null;
+      this.transformationListView.Location = new System.Drawing.Point(0, 0);
+      this.transformationListView.Name = "transformationListView";
+      this.transformationListView.ReadOnly = false;
+      this.transformationListView.Size = new System.Drawing.Size(627, 482);
+      this.transformationListView.TabIndex = 0;
+      // 
       // TransformationView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.lblFilterNotice);
       this.Controls.Add(this.preserveColumnsCheckbox);
       this.Controls.Add(this.applyButton);
@@ -105,4 +118,5 @@
     private System.Windows.Forms.Button applyButton;
     private System.Windows.Forms.CheckBox preserveColumnsCheckbox;
+    private System.Windows.Forms.Label lblFilterNotice;
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs	(revision 10976)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs	(revision 10977)
@@ -48,4 +48,35 @@
       } else {
         transformationListView.Content = Content.CheckedTransformationList;
+        CheckFilters();
+      }
+    }
+
+    /// <summary>
+    /// Adds eventhandlers to the current instance.
+    /// </summary>
+    protected override void RegisterContentEvents() {
+      Content.FilterLogic.FilterChanged += FilterLogic_FilterChanged;
+    }
+
+    /// <summary>
+    /// Removes the eventhandlers from the current instance.
+    /// </summary>
+    protected override void DeregisterContentEvents() {
+      Content.FilterLogic.FilterChanged -= FilterLogic_FilterChanged;
+    }
+
+    void FilterLogic_FilterChanged(object sender, EventArgs e) {
+      if (Content != null) {
+        CheckFilters();
+      }
+    }
+
+    private void CheckFilters() {
+      if (Content.FilterLogic.IsFiltered) {
+        applyButton.Enabled = false;
+        lblFilterNotice.Visible = true;
+      } else {
+        applyButton.Enabled = true;
+        lblFilterNotice.Visible = false;
       }
     }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.4/Implementations/DataGridContent.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.4/Implementations/DataGridContent.cs	(revision 10976)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.4/Implementations/DataGridContent.cs	(revision 10977)
@@ -31,23 +31,7 @@
   public class DataGridContent : Item, IViewShortcut, IDataGridContent {
 
-    private readonly IDataGridLogic dataGridLogic;
-    private readonly IManipulationLogic manipulationLogic;
-    private readonly IFilterLogic filterLogic;
-
-    public IManipulationLogic ManipulationLogic {
-      get { return manipulationLogic; }
-    }
-
-    public IDataGridLogic DataGridLogic {
-      get {
-        return dataGridLogic;
-      }
-    }
-
-    public IFilterLogic FilterLogic {
-      get {
-        return filterLogic;
-      }
-    }
+    public IManipulationLogic ManipulationLogic { get; private set; }
+    public IDataGridLogic DataGridLogic { get; private set; }
+    public IFilterLogic FilterLogic { get; private set; }
 
     public static new Image StaticItemImage {
@@ -57,5 +41,5 @@
     public int Rows {
       get {
-        return dataGridLogic.Rows;
+        return DataGridLogic.Rows;
       }
       set {
@@ -66,5 +50,5 @@
     public int Columns {
       get {
-        return dataGridLogic.Columns;
+        return DataGridLogic.Columns;
       }
       set {
@@ -75,5 +59,5 @@
     public IEnumerable<string> ColumnNames {
       get {
-        return dataGridLogic.ColumnNames;
+        return DataGridLogic.ColumnNames;
       }
       set {
@@ -84,5 +68,5 @@
     public IEnumerable<string> RowNames {
       get {
-        return dataGridLogic.RowNames;
+        return DataGridLogic.RowNames;
       }
       set {
@@ -105,7 +89,7 @@
 
     public DataGridContent(IDataGridLogic theDataGridLogic, IManipulationLogic theManipulationLogic, IFilterLogic theFilterLogic) {
-      dataGridLogic = theDataGridLogic;
-      manipulationLogic = theManipulationLogic;
-      filterLogic = theFilterLogic;
+      DataGridLogic = theDataGridLogic;
+      ManipulationLogic = theManipulationLogic;
+      FilterLogic = theFilterLogic;
     }
 
@@ -120,14 +104,14 @@
 
     public string GetValue(int rowIndex, int columnIndex) {
-      return dataGridLogic.GetValue(columnIndex, rowIndex);
+      return DataGridLogic.GetValue(columnIndex, rowIndex);
     }
 
     public bool SetValue(string value, int rowIndex, int columnIndex) {
-      return dataGridLogic.SetValue(value, columnIndex, rowIndex);
+      return DataGridLogic.SetValue(value, columnIndex, rowIndex);
     }
 
     public event DataPreprocessingChangedEventHandler Changed {
-      add { dataGridLogic.Changed += value; }
-      remove { dataGridLogic.Changed -= value; }
+      add { DataGridLogic.Changed += value; }
+      remove { DataGridLogic.Changed -= value; }
     }
 
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.4/Implementations/TransformationContent.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.4/Implementations/TransformationContent.cs	(revision 10976)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.4/Implementations/TransformationContent.cs	(revision 10977)
@@ -30,10 +30,16 @@
 
     public IPreprocessingData Data { get; private set; }
+    public IFilterLogic FilterLogic { get; private set; }
 
     public ICheckedItemList<ITransformation> CheckedTransformationList { get; private set; }
 
-    public TransformationContent(IPreprocessingData data) {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Method; }
+    }
+
+    public TransformationContent(IPreprocessingData data, IFilterLogic filterLogic) {
       Data = data;
       CheckedTransformationList = new CheckedItemList<ITransformation>();
+      FilterLogic = filterLogic;
     }
 
@@ -44,8 +50,4 @@
     }
 
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Method; }
-    }
-
     public override IDeepCloneable Clone(Cloner cloner) {
       return new TransformationContent(this, cloner);