Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs	(revision 10998)
@@ -62,5 +62,5 @@
       }
       return null;
-    }
+    } 
 
     private bool CanInstanciateTransformation(Type type) {
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ComparisonFilterView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ComparisonFilterView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ComparisonFilterView.cs	(revision 10998)
@@ -72,9 +72,5 @@
       if (Content.ConstrainedValue != null) {
         this.cbAttr.Items.AddRange(Content.ConstrainedValue.VariableNames.ToArray<string>());
-        //if (!string.IsNullOrEmpty(Content.ConstraintColumn))
         this.cbAttr.SelectedItem = this.cbAttr.Items[Content.ConstraintColumn];
-
-        //if (Content.ConstraintColumn != null)
-        //{
         cbAttr.SelectedItem = Content.ConstraintColumn;
         if (Content.ConstraintData != null)
@@ -82,5 +78,4 @@
         else
           this.Content_ConstraintColumnChanged(cbAttr, EventArgs.Empty);
-        //}
       }
     }
@@ -134,10 +129,4 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      /*
-      cbAttr.Enabled = !this.ReadOnly && Content != null;
-      cbFilterOperation.Enabled = !this.ReadOnly && Content != null;
-      tbFilterData.Enabled = Content != null;
-      tbFilterData.ReadOnly = ReadOnly;
-       * */
       cbAttr.Enabled = Content != null && !Content.Active;
       cbFilterOperation.Enabled = Content != null && !Content.Active;
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataCompletenessView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataCompletenessView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataCompletenessView.cs	(revision 10998)
@@ -43,5 +43,4 @@
     }
 
-    
     private void InitData()
     {
@@ -84,6 +83,4 @@
       chart.ChartAreas[0].AxisY.IsReversed = true;
     }
-
-
 
     private void CreateSeries(List<List<int>> yValuesPerColumn)
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 10998)
@@ -535,5 +535,4 @@
             e.CellBounds.Bottom);
       }
-
       e.PaintContent(e.CellBounds);
       e.Handled = true;
@@ -665,5 +664,4 @@
     #endregion
 
-
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs	(revision 10998)
@@ -32,4 +32,5 @@
   [Content(typeof(IPreprocessingContext), false)]
   public partial class DataPreprocessingView : ItemView {
+
     public DataPreprocessingView() {
       InitializeComponent();
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.cs	(revision 10998)
@@ -57,13 +57,9 @@
 
     private void UpdateFilterInfo() {
-        //List<IFilter> filters = checkedFilterView.ItemCollection.ToList<IFilter>();
         List<IFilter> filters = Content.Filters.ToList();
-
         int activeFilters = filters.Count(c => c.Active);
-
         applyFilterButton.Enabled = (activeFilters > 0);
         rBtnAnd.Enabled = (activeFilters > 0);
         rBtnOr.Enabled = (activeFilters > 0);
-        //btnReset.Enabled = (activeFilters > 0);
         Content.FilterLogic.Reset();
         bool[] result = Content.FilterLogic.Preview(filters, rBtnAnd.Checked);
@@ -121,14 +117,4 @@
     }
 
-    /*
-    private void btnReset_Click(object sender, EventArgs e)
-    {
-      if (Content != null)
-      {
-        Content.FilterLogic.Reset();
-      }
-    }
-     * */
-
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingScatterPlotView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingScatterPlotView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingScatterPlotView.cs	(revision 10998)
@@ -462,5 +462,5 @@
       if (chartDoubleClick != null)
         chartDoubleClick(this, e);
-    }
+    } 
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 10998)
@@ -13,11 +13,12 @@
   public partial class ScatterPlotSingleView : ItemView {
 
-    public ScatterPlotSingleView() {
-      InitializeComponent();
-    }
-
     public new ScatterPlotContent Content {
       get { return (ScatterPlotContent)base.Content; }
       set { base.Content = value; }
+    }
+
+    public ScatterPlotSingleView()
+    {
+      InitializeComponent();
     }
 
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs	(revision 10998)
@@ -33,11 +33,12 @@
   public partial class TransformationView : AsynchronousContentView {
 
+    public new TransformationContent Content
+    {
+      get { return (TransformationContent)base.Content; }
+      set { base.Content = value; }
+    }
+
     public TransformationView() {
       InitializeComponent();
-    }
-
-    public new TransformationContent Content {
-      get { return (TransformationContent)base.Content; }
-      set { base.Content = value; }
     }
 
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/Utils/FindPreprocessingItemsIterator.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/Utils/FindPreprocessingItemsIterator.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/Utils/FindPreprocessingItemsIterator.cs	(revision 10998)
@@ -26,4 +26,5 @@
 namespace HeuristicLab.DataPreprocessing.Views {
   class FindPreprocessingItemsIterator : IFindPreprocessingItemsIterator {
+
     private IDictionary<int, IList<int>> items;
     private Tuple<int, int> currentCell;
@@ -31,7 +32,6 @@
     public FindPreprocessingItemsIterator(IDictionary<int, IList<int>> items) {
       this.items = items;
-      Reset();
+      Reset(); 
     }
-
 
     public void SetStartCell(int columnIndex, int rowIndex) {
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/Utils/IFindPreprocessingItemsIterator.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/Utils/IFindPreprocessingItemsIterator.cs	(revision 10997)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/Utils/IFindPreprocessingItemsIterator.cs	(revision 10998)
@@ -27,5 +27,5 @@
     bool MoveNext();
     void Reset();
-    void SetStartCell(int columnIndex, int rowIndex);
+    void SetStartCell(int columnIndex, int rowIndex); 
   }
 }